<template>
  <Page>
    <ElForm v-show="showSearchForm" inline @submit.prevent="paging">
      <!-- <ElFormItem label="业务类型">
        <ElInput
          v-model="searchForm.bizType"
          placeholder="业务类型"/>
      </ElFormItem> -->
      <ElFormItem label="分类名称">
        <ElInput v-model="searchForm.categoryName" placeholder="分类名称" />
      </ElFormItem>

      <ElFormItem>
        <ElButton :icon="elIcons.Search" :loading="searching" native-type="submit" type="primary">搜索</ElButton>
        <ElButton :icon="elIcons.Refresh" :loading="searching" @click="reset">重置</ElButton>
      </ElFormItem>
    </ElForm>

    <div class="tool-bar">
      <ElButton :icon="elIcons.Plus" type="primary" @click="addHandler">新建</ElButton>
      <ElButton :icon="elIcons.Filter" type="default" @click="showSearchForm = !showSearchForm" />
    </div>

    <ElTable v-loading="searching" :data="tableData" cell-class-name="table-cell" class="table-list" empty-text="暂无数据" header-row-class-name="table-header" row-key="id">
      <ElTableColumn label="Id" prop="id" />
      <ElTableColumn label="业务类型" prop="bizTypeName" />
      <ElTableColumn label="分类名称" prop="categoryName" />
      <ElTableColumn label="图片" prop="picture">
        <template #default="{ row }">
          <el-image :preview-src-list="[AppApi.fileUrl(row.picture)]" :src="AppApi.fileUrl(row.picture)" preview-teleported show-progress style="width: 60px; height: 60px" />
        </template>
      </ElTableColumn>
      <ElTableColumn label="创建时间" prop="createTime" />
      <ElTableColumn label="修改时间" prop="modifyTime" />
      <ElTableColumn label="操作" width="180">
        <template #default="scope">
          <div class="action-btn">
            <ElPopconfirm confirm-button-text="是" cancel-button-text="否" confirm-button-type="danger" cancel-button-type="primary" placement="top" title="是否删除当前数据?" width="180" @confirm="delHandler(scope)">
              <template #reference>
                <ElButton text type="danger" :loading="deling">删除</ElButton>
              </template>
            </ElPopconfirm>
            <ElButton text type="primary" @click="modifyHandler(scope)">修改</ElButton>
          </div>
        </template>
      </ElTableColumn>
    </ElTable>
    <ElPagination layout="->, sizes, total, prev, pager, next" v-model:current-page="searchForm.current" v-model:page-size="searchForm.size" :total="totalCount" :page-sizes="[10, 20, 50, 100, 500]" :hide-on-single-page="false" :teleported="false" @change="paging" />
    <GoodsCategoryForm ref="goodsCategoryForm" @edit-succ="paging" />
  </Page>
</template>

<script lang="ts" setup>
import GoodsCategoryApi from "@/pages/gds/goods-category/goods-category-api.ts";
import GoodsCategoryForm from "@/pages/gds/goods-category/GoodsCategoryForm.vue";
import Page from "@/components/page/Page.vue";
import { elIcons } from "@/common/element/element.ts";
import Utils from "@/common/utils";
import AppApi from "@/common/app/app-api.ts";

const totalCount = ref(0);
const tableData = Utils.resetAble(reactive<GoodsCategoryTypes.SearchGoodsCategoryResult[]>([]));
const searchForm = Utils.resetAble(
  reactive<GoodsCategoryTypes.SearchGoodsCategoryParam>({
    current: 1,
    size: 20,
  })
);
const searching = ref(false);
const deling = ref(false);
const showSearchForm = ref(true);
const goodsCategoryFormIns = useTemplateRef<InstanceType<typeof GoodsCategoryForm>>("goodsCategoryForm");

function showDialog(data?: GoodsCategoryTypes.SearchGoodsCategoryResult) {
  goodsCategoryFormIns.value?.open(data);
}

function delHandler({ row }: { row: GoodsCategoryTypes.SearchGoodsCategoryResult }) {
  deling.value = true;
  GoodsCategoryApi.del([row.id!])
    .then(() => {
      ElMessage.success("删除成功");
      paging();
    })
    .finally(() => {
      deling.value = false;
    });
}

function modifyHandler({ row }: { row: GoodsCategoryTypes.SearchGoodsCategoryResult }) {
  showDialog(row);
}

function addHandler() {
  showDialog();
}

function reset() {
  searchForm.$reset();
  paging();
}

function paging() {
  searching.value = true;
  GoodsCategoryApi.paging(searchForm)
    .then((res) => {
      totalCount.value = res.data?.total ?? 0;
      tableData.$reset(res.data?.records ?? []);
    })
    .finally(() => {
      searching.value = false;
    });
}
onMounted(() => {
  paging();
});
</script>

<style lang="stylus" scoped>
.table-list {
  flex 1;
  margin 0 0 20px 0
  width 100%

  :deep(.table-header) {
    color #454C59

    th {
      background-color #EDF1F7
      font-weight 500
      position relative

      & > div {
        display flex
        gap 5px
        align-items center
      }

      &:not(:first-child) > div::before {
        position: absolute;
        top: 50%;
        left: 1px;
        width: 1px;
        background-color: #D3D7DE;
        transform: translateY(-50%);
        content: "";
        height 50%
      }
    }
  }

  :deep(.table-cell) {
    color #2F3540
  }
  .action-btn {
    width 100%
    display flex
    flex-wrap wrap

    & > button {
      margin 0
    }
  }
}

.tool-bar {
  display flex
  justify-content space-between
  margin 0 0 20px 0
}
</style>
